
#include <SPI.h>
#include <MFRC522.h>
////////////////////////////////////////////oled//////////////////////////////////////////
#include <U8g2lib.h>
U8G2_SSD1306_128X64_NONAME_1_HW_I2C u8g2(U8G2_R0, /* reset=*/ U8X8_PIN_NONE);
////////////////////////////////////oled////////////////////////////////////////////////


#define RST_PIN         9           // Configurable, see typical pin layout above
#define SS_PIN          8 //10        // Configurable, see typical pin layout above

MFRC522 mfrc522(SS_PIN, RST_PIN);   // Create MFRC522 instance

//*****************************************************************************************//
void setup() {
  Serial.begin(9600);                                           // Initialize serial communications with the PC
  SPI.begin();                                                  // Init SPI bus
  mfrc522.PCD_Init();                                              // Init MFRC522 card
  Serial.println(F("Read personal data on a MIFARE PICC:"));  
 ////////////////////////////////////////////////oled////////////////////////////////////////////
  u8g2.begin();
  u8g2.enableUTF8Print();
   
 //////////////////////////////////////////////////oled////////////////////////////////////////
    //shows in serial that it is ready to read
}

//*****************************************************************************************//
void loop() {

  ////////////////////////////////////////////////oled/////////////////////////////////////
        u8g2.firstPage();
  do {
     u8g2.setFont(u8g2_font_open_iconic_all_2x_t);
      u8g2.drawGlyph(65,55, 156); 
        u8g2.drawGlyph(35,55, 102); 
    u8g2.setFont(u8g2_font_ncenB08_tr);
    u8g2.setCursor(10, 10);
    u8g2.print("Put RFID card to get "); 
    u8g2.setCursor(10, 24);
    u8g2.print("Your secreat message"); 
  } while ( u8g2.nextPage() );
  /////////////////////////////////////////////////////oled////////////////////////////
  
  // Prepare key - all keys are set to FFFFFFFFFFFFh at chip delivery from the factory.
  MFRC522::MIFARE_Key key;
  for (byte i = 0; i < 6; i++) key.keyByte[i] = 0xFF;

  //some variables we need
  byte block;
  byte len;
  MFRC522::StatusCode status;

  //-------------------------------------------

  // Reset the loop if no new card present on the sensor/reader. This saves the entire process when idle.
  if ( ! mfrc522.PICC_IsNewCardPresent()) {
    return;
  }

  // Select one of the cards
  if ( ! mfrc522.PICC_ReadCardSerial()) {
    return;
  }

  Serial.println(F("**Card Detected:**"));
          u8g2.firstPage();
  do {
    u8g2.setFont(u8g2_font_ncenB08_tr);
    u8g2.setCursor(20, 10);
    u8g2.print("**Card Detected:**"); 
  } while ( u8g2.nextPage() );

  //-------------------------------------------

  mfrc522.PICC_DumpDetailsToSerial(&(mfrc522.uid)); //dump some details about the card

  //mfrc522.PICC_DumpToSerial(&(mfrc522.uid));      //uncomment this to see all blocks in hex

  //-------------------------------------------

  Serial.print(F("Name: "));
          u8g2.firstPage();
  do {
    u8g2.setFont(u8g2_font_ncenB08_tr);
    u8g2.setCursor(0, 10);
    u8g2.println("Yor meaasge"); 
  } while ( u8g2.nextPage() );
    
  byte buffer1[18];

  block = 4;
  len = 18;

  //------------------------------------------- GET FIRST NAME
  status = mfrc522.PCD_Authenticate(MFRC522::PICC_CMD_MF_AUTH_KEY_A, 4, &key, &(mfrc522.uid)); //line 834 of MFRC522.cpp file
  if (status != MFRC522::STATUS_OK) {
    Serial.print(F("Authentication failed: "));
    Serial.println(mfrc522.GetStatusCodeName(status));
    return;
  }

  status = mfrc522.MIFARE_Read(block, buffer1, &len);
  if (status != MFRC522::STATUS_OK) {
    Serial.print(F("Reading failed: "));
     
        //////////////////////////////////////////////
        u8g2.firstPage();
  do {
      u8g2.setFont(u8g2_font_ncenB08_tr);
    u8g2.setCursor(10, 10);
    u8g2.println("Reading failed: ");
   
  } while ( u8g2.nextPage() );

  ///////////////////////////////////////////////////////
    Serial.println(mfrc522.GetStatusCodeName(status));
    return;
  }
 String myString1 = String(buffer1[18]);
  //PRINT FIRST NAME
  for (uint8_t i = 0; i < 16; i++)
  {
  
    if (buffer1[i] != 32)
    {
      String str((char*) buffer1);

      //////////////////////////////////////
            u8g2.firstPage();
  do {
     u8g2.setFont(u8g2_font_open_iconic_all_2x_t);
     u8g2.drawGlyph(25,15, 157); 
     u8g2.drawGlyph(55,15, 66); 
      u8g2.setFont(u8g2_font_ncenB08_tr);
    u8g2.setCursor(0, 30);
   
    u8g2.println(str);
   
  } while ( u8g2.nextPage() );
  ///////////////////////////////////////
   
      
    }
  }
  Serial.print(" ");

  //---------------------------------------- GET LAST NAME

  byte buffer2[18];
  block = 1;

  status = mfrc522.PCD_Authenticate(MFRC522::PICC_CMD_MF_AUTH_KEY_A, 1, &key, &(mfrc522.uid)); //line 834
  if (status != MFRC522::STATUS_OK) {
    Serial.print(F("Authentication failed: "));
    Serial.println(mfrc522.GetStatusCodeName(status));
    return;
  }

  status = mfrc522.MIFARE_Read(block, buffer2, &len);
  if (status != MFRC522::STATUS_OK) {
    Serial.print(F("Reading failed: "));
    Serial.println(mfrc522.GetStatusCodeName(status));
    return;
  }

  //PRINT LAST NAME
  for (uint8_t i = 0; i < 16; i++) {
    ////////////////////////////////


  String str((char*) buffer2);

            u8g2.firstPage();
  do {
    u8g2.setFont(u8g2_font_open_iconic_all_2x_t);
     u8g2.drawGlyph(25,15, 157); 
     u8g2.drawGlyph(55,15, 66); 
    u8g2.setFont(u8g2_font_ncenB08_tr);
    u8g2.setCursor(0,50);
    u8g2.print("is your Mail password");
    u8g2.setCursor(0,30);
    u8g2.println(str);
  
   
  } while ( u8g2.nextPage() );

   Serial.write(buffer2[i] );


//////////////////////
  

    //////////////////////////////
    
  }


  //----------------------------------------

  Serial.println(F("\n**End Reading**\n"));

  delay(1000); //change value if you want to read cards faster

  mfrc522.PICC_HaltA();
  mfrc522.PCD_StopCrypto1();
}
//*****************************************************************************************//
